﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom View class 
#Event: ChangeValue (Value As Int)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: MinValue, DisplayName: MinValue, FieldType: Int, DefaultValue: 0, MinRange: 0, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: MaxValue, DisplayName: MaxValue, FieldType: Int, DefaultValue: 100, MinRange: 0, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: Value, DisplayName: Value, FieldType: Int, DefaultValue: 0, MinRange: 0, Description: Actual value
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: Color, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	'Private Const DefaultColorConstant As Int = -984833 'ignore
	
	Private ColorSlide As Int
	Private MinValue,MaxValue As Int = 0
	Private Value As Int = 0
	Private valueString As String
	
	Private PositionPixels(2) As Double
	Private mLimit(2) As Int
	
	Private Pan As Panel
	Private firsttrack As B4XView
	Private LabMin,LabMax As Label
	Private Ball As Label
	Private mparent As Panel
	Private thumb As Panel
	Private C As B4XCanvas
	Private cvstrackPanel As B4XCanvas
	Private rect As B4XRect
	Private rectPanelFront As B4XRect
	Private backgroundpath As B4XPath
	Private xui As XUI
	
	Private mX0, mX1 As Double
	Private my0, my1, my2 As Double
	Private mScale As Double
	Private PosIndex As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	Pan.Initialize("Panel")
	firsttrack = xui.CreatePanel("")
	LabMin.Initialize("")
	LabMax.Initialize("")
	Ball.Initialize("")
	thumb.Initialize("")
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
    mparent = mBase.Parent
	If Props.ContainsKey("Color") Then ColorSlide=Props.Get("Color")
	If Props.ContainsKey("MinValue") Then MinValue=Props.Get("MinValue")
	If Props.ContainsKey("MaxValue") Then MaxValue=Props.Get("MaxValue")
	If Props.ContainsKey("Value") Then Value=Props.Get("Value")
	
	mBase.color=Colors.Transparent
	ColorSlide = Colors.RGB(164, 212, 232)
	Pan.Color= Colors.RGB(164, 212, 232) '''ColorSlide
	
	LabMin.Color=Colors.Transparent
	LabMin.TextColor=Colors.White
	LabMin.Gravity=Gravity.CENTER

	LabMax.Color=Colors.Transparent
	LabMax.TextColor=Colors.White
	LabMax.Gravity=Gravity.CENTER
	Ball.TextColor=Colors.Black
	mparent.AddView(Ball, 0, mBase.Top - 80dip/2, 80dip, 80dip)
	Ball.SetBackgroundImage(MyCorner(ColorSlide,80dip/3))
	Ball.Gravity=Gravity.CENTER

	Dim r As Reflector
	r.Target = thumb
	r.RunMethod2("requestDisallowInterceptTouchEvent", False, "java.lang.boolean")
	
	thumb.SetBackgroundImage(MyCorner2(Colors.white, 25dip/2))
	mLimit(0) = 0
	mLimit(1) = MaxValue
	mBase.AddView(Pan,0,mBase.Height/2,mBase.Width,mBase.Height/2)
	cvstrackPanel.Initialize(Pan)
	rectPanelFront.Initialize(0, 0, Pan.Width, Pan.Height)
	mBase.AddView(firsttrack, 0, Pan.Top + 2dip, mBase.Width, 2dip)
	firsttrack.SendToBack
	firsttrack.Color = Colors.Gray
	Ball.Visible = False
	mparent.AddView(thumb, Ball.Width/2 - 20dip/2, mBase.Top - 5dip/2, 20dip, 20dip)
	my0 = 0.2 * mBase.Height
	my1 = my0 + 8dip + 0.05 * mBase.Height
	my2 = 0.9 * mBase.Height
	mX0 = MinValue
	mX1 = Base.Width
	mScale = (mX1 - mX0) / MaxValue
	PositionPixels(0) = MinValue * mScale + mX0
	DrawBackGround
	setValue(Value,True)
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub DrawBackGround
	cvstrackPanel.ClearRect(rectPanelFront)
	backgroundpath.InitializeRoundedRect(rectPanelFront, 10dip)
	cvstrackPanel.ClipPath(backgroundpath)
	cvstrackPanel.DrawRect(rectPanelFront, ColorSlide, True, 1dip)
End Sub

Public Sub DrawFrontTrack
	cvstrackPanel.ClearRect(rectPanelFront)
	'''cvstrackPanel.DrawLine(PositionPixels(0),my0, PositionPixels(1), my0, ColorSlide, 3dip) 
	cvstrackPanel.DrawLine(0, my0, PositionPixels(1), my0, ColorSlide, 3dip)
	cvstrackPanel.Invalidate
End Sub

'''private Sub Corner(Color As Int, Radius As Int) As ColorDrawable
'''	Dim cdb As ColorDrawable
'''
'''	cdb.Initialize2(Colors.White,Radius,5dip,Color)
'''	Return cdb
'''End Sub

private Sub MyCorner(Color As Int, Radius As Int) As Bitmap
	Dim B As Bitmap
	Dim R As Int = 80dip+20dip/2''mBase.Height/2
	Dim Gr As Int = 80dip + 20dip'' mBase.Height
	Dim Rect1 As Rect
	Dim mpath As Path
	Dim RectF As JavaObject
	
	RectF = RectF.InitializeNewInstance("android.graphics.RectF", Null)
	B.InitializeMutable(Gr,Gr)
	Rect1.Initialize(R/4, R, Gr-(R/4), Gr)
	
	C.Initialize(Ball)
	Dim x0 As Float = C.TargetView.GetBitmap.Width/2.0
	Dim y0 As Float = C.TargetView.GetBitmap.Height - Radius / 3.0
	
	mpath.Initialize(x0, y0)
	Dim jo As JavaObject
	jo = mpath
	jo.RunMethod("moveTo", Array As Object(x0, y0))

	Dim x1 As Float = C.TargetView.GetBitmap.Width / 2.0 - Sqrt(3) / 2.0 * Radius
	Dim y1 As Float = 3 / 2 * Radius
	jo.RunMethod("quadTo", Array As Object((x1 - 2*Density), (y1 - 2*Density), x1, y1))
	Dim f1, f2, f3, f4 As Float
	f1 = C.TargetView.GetBitmap.Width / 2.0 - Radius
	f2 = 0
	f3 = C.TargetView.GetBitmap.Width / 2.0 + Radius
	f4 = 2.0 * Radius
	RectF.RunMethod("set", Array As Object(f1, f2, f3, f4))
	rect.Initialize(f1 + 8dip, 10dip, C.TargetView.GetBitmap.Width - 20dip, 35dip)
	Dim f5, f6 As Float
	f5 = 150
	f6 = 240
	jo.RunMethod("arcTo", Array As Object(RectF, f5, f6))
	jo.RunMethod("close", Null)
	C.DrawPath(mpath, Color, True, 1)
	C.DrawRect(rect, Colors.RGB(164, 212, 232), True, 20dip)

	Return C.TargetView.GetBitmap
End Sub

Private Sub MyCorner2(color As Int, radius As Int) As Bitmap
	Dim B As Bitmap
	Dim C2 As Canvas
	Dim R As Int = 25dip/2''mBase.Height
	Dim Gr As Int = 25dip''mBase.Height
	
	B.InitializeMutable(Gr,Gr)
	C2.Initialize2(B)
	
	C2.DrawCircle(R, R, radius, ColorSlide, True, 0)
	Return C2.Bitmap
End Sub

public Sub setValue(pos As Int,Click As Boolean)
	If pos>=MinValue And pos<=MaxValue Then 
		Value=pos
		valueString = pos
		C.ClearRect(rect)
		C.DrawRect(rect, Colors.RGB(164, 212, 232), True, 20dip)
		Ball.Left = ((Value-MinValue)/(MaxValue-MinValue))*(mBase.Width-(mBase.Height/2)) + mBase.Left - 20dip
		thumb.Left = ((Value-MinValue)/(MaxValue-MinValue))*(mBase.Width-(mBase.Height/2)) + mBase.Left
		C.DrawText(valueString, rect.CenterX - 2dip, rect.CenterY+8dip, xui.CreateFont(Typeface.DEFAULT, 25), Colors.White, "CENTER")
		PositionPixels(1) = pos * mScale + mX0
		DrawFrontTrack
		If Click Then 	
			Ball.SetLayoutAnimated(200, Ball.left,mBase.top - 35dip, 50dip, 55dip)
			thumb.SetLayout(Ball.Left + 15dip, mBase.Top - 5dip/2, 20dip, 20dip)
		End If
	End If
End Sub

Public Sub getValue As Int
	Return Value
End Sub

Private Sub Panel_Touch (Action As Int, X As Float, Y As Float)
	
	Private xx As Double
	xx = X
	xx = Max(mX0, xx)
	xx = Min(mX1, xx)
	
	Select Action
		Case 0 ' ACTION_DOWN
			PosIndex = 1
			Log("posIndex: " & PosIndex)
			Dim P As Int = ((X/mBase.Width - mBase.Left)*(MaxValue-MinValue))+MinValue
			PositionPixels(PosIndex) = xx
			mLimit(0) = Floor((xx - mX0) / mScale + .5)
			DrawFrontTrack
			Ball.SetVisibleAnimated(200, True)
			setValue(P,True)
			If SubExists(mCallBack,mEventName & "_ChangeValue") Then CallSub2(mCallBack,mEventName & "_ChangeValue",mLimit(0))
		Case 1 ' ACTION_UP
			'''Ball.SetLayoutAnimated(200,Ball.Left,mBase.Height/2,mBase.Height/2,mBase.Height/2)
			Ball.SetLayoutAnimated(200, Ball.Left, mBase.top - 35dip, 50dip, 55dip)
			thumb.SetLayout(thumb.Left, mBase.Top - 5dip/2, 20dip, 20dip)
			Ball.SetVisibleAnimated(200, False)
		Case 2 ' ACTION_MOVE
			Dim P As Int = ((X/mBase.Width)*(MaxValue-MinValue))+MinValue
			PositionPixels(PosIndex) = xx
			DrawFrontTrack
			setValue(P,True)
			If SubExists(mCallBack,mEventName & "_ChangeValue") Then CallSub2(mCallBack,mEventName & "_ChangeValue",mLimit(0))
			mLimit(0) = Floor((xx - mX0) / mScale + .5)
		Case 3 ' Error
	End Select
End Sub

